/*
 * @param {Object} target 目标对象。
 * @param {Object} source 源对象。
 * @param {boolean} deep 是否复制(继承)对象中的对象。
 * @returns {Object} 返回继承了source对象属性的新对象。
 */
Object.extend = function (target, source) {
  for (var p in source) {
    if (source.hasOwnProperty(p)) {
      target[p] = source[p];
    }
  }
  return target;
};
Object.isEmpty = function (e) {
  var t;
  for (t in e)
    return !1;
  return !0
};
Object.isJson = function (json) {
  return typeof(json) == "object" && Object.prototype.toString.call(json).toLowerCase() == "[object object]" && !json.length;
}
// JavaScript Document
Object.loadjscssfile=function(filename,filetype){
    if(filetype == "js"){
        var fileref = document.createElement('script');
        fileref.setAttribute("type","text/javascript");
        fileref.setAttribute("src",filename);
    }else if(filetype == "css"){

        var fileref = document.createElement('link');
        fileref.setAttribute("rel","stylesheet");
        fileref.setAttribute("type","text/css");
        fileref.setAttribute("href",filename);
    }
   if(typeof fileref != "undefined"){
        document.getElementsByTagName("head")[0].appendChild(fileref);
    }
}

var common = common || {}
var uid = android.getUserId();
common.SECTION_CACHE_KEY = "unips_section_cache_" + uid;
common.SECTION_NO_FOR_ANDROID_CACHE_KEY = "unips_section_no_for_android_cache";
common.isAndroid = function () {
  return /(Android);?[\s\/]+([\d.]+)?/.test(navigator.userAgent)
}
/*
 *公用的函数
 */
var bridge = function () {
  var _existSectionCache = function () {
      var sectionCacheData = localStorage.getItem(common.SECTION_CACHE_KEY);
      if (!sectionCacheData)
        return null;
      return JSON.parse(sectionCacheData)
    },
    _setTrainData = function (data, tutorialId, unitId) {
      if (data) {
        if (!Object.isJson(data)) {
          data = JSON.parse(data);
        }
        var sections = [],
          cacheSection;
        //unips_section_cache:{"courseId1":{"unitId":{"sectionIdx":0,"section":section,"currQuesNo":5}},"courseId2":{"unitId":{"sectionIdx":1,"section":section,"currQuesNo":5}}}
        cacheSection = _getSectionCache(tutorialId, unitId);

        // 如果该课程的本地存储不存在直接返回data
        if (cacheSection) {
          for (var i = 0; i < data.parts.length; i++) {
            sections = sections.concat(data.parts[i].children)
          }
          var section = sections[cacheSection.sectionIdx];

          //判断单元 section 是否相等
          // 复制cache的数据的data
          Object.extend(section, cacheSection.section);
        }
        // 赋值数据到window对象上
        window.trainData = data;
      } else {
        alert("data is undefined");
      }
    },
    _getSectionCache = function (courseId, unitId) {
      var cacheSections = _existSectionCache(courseId, unitId);
      if (!cacheSections) return null;
      var course = cacheSections[courseId];
      if (course) {
        if (course[unitId])
          return course[unitId];
      }
    },
    _goResult = function (data, url) {
      if (data) {
        window.resData = JSON.parse(data);
      }
      //清空section缓存
      localStorage.removeItem(common.SECTION_CACHE_KEY);
      _redirect(url);
    },
    _redirect = function (uri) {
      if (navigator.userAgent.match(/Android/i))
        document.location = uri;
      else
        window.location.replace(uri);
    };
  return {
    existSectionCache: function () {
      return _existSectionCache();
    },
    //原生调用此方法写入数据
    setTrainData: function (data, tutorialId, unitId) {
      _setTrainData(data, tutorialId, unitId);
    },
    getSectionCache: function (tutorialId, unitId) {
      return _getSectionCache(tutorialId, unitId);
    },
    //原生调用此方法跳转
    goResult: function (data, url) {
      _goResult(data, url);
    }
  }
}();
window.common = Object.extend(common, bridge);

common.getSectionId = function (sectionNo) {
    if(!trainData){
        alert("数据异常.");
        return;
    }
    var sections = [];
    for (var i = 0; i < trainData.parts.length; i++) {
      sections = sections.concat(trainData.parts[i].children)
    }
    return sections[sectionNo].id;
};
common.getPartId = function (sectionNo) {
    if (!trainData) {
      alert("数据异常.");
      return;
    }
    var idx = 0;
    for (var i = 0; i < trainData.parts.length; i++) {
      var part = trainData.parts[i];
      for (var j = 0; j < part.children.length; j++) {
        if (idx == sectionNo) {
          return part.id;
        }
        idx++;
      }
    }
};
/********************题目模板 开始********************/
//数据处理
//从原生js获取数据传入给模板
var reqTrainData =android.getReqTrainData && android.getReqTrainData();
if (reqTrainData) {
  reqTrainData = JSON.parse(reqTrainData);
  common.setTrainData(reqTrainData.bigJson, reqTrainData.tutorialId, reqTrainData.unitId);
}
//模板js获取本地保存的section提交给原生 调用原生的js提交数据
common.submitQuesAnswer = function (tutorialId, unitId, sectionIdx) {
  if (window.android) {
    var sectionId = common.getSectionId(sectionIdx);
    var partId = common.getPartId(sectionIdx);
    android.submitQuesAnswer(JSON.stringify(common.getSectionCache(tutorialId, unitId).section),sectionId,partId);
  } else {
    var url = location.hash.replace(/(^#!)\S*(\/c\/\d*\/u\/\d*\/s\/)\d*(\/q\/\d*)/g, '/$1/result$2' + sectionIdx + "$3")
    common.goResult("", url);
  }
}
/********************题目模板 结束********************/

/********************统计模板 开始********************/
var studentSummaryData =android.getStudentSummaryData && android.getStudentSummaryData();
studentSummaryData && (window.studentSummaryData = JSON.parse(studentSummaryData));
var studentSummaryDetailData =android.getStudentSummaryDetailData && android.getStudentSummaryDetailData();
studentSummaryDetailData && (window.studentSummaryDetailData = JSON.parse(studentSummaryDetailData));
var teacherSummaryData =android.getTeacherSummaryData && android.getTeacherSummaryData();
teacherSummaryData && (window.teacherSummaryData = JSON.parse(teacherSummaryData));
var teacherSummaryDetailData =android.getTeacherSummaryDetailData && android.getTeacherSummaryDetailData();
teacherSummaryDetailData && (window.teacherSummaryDetailData = JSON.parse(teacherSummaryDetailData));
/********************统计模板 结束********************/
//动态创建js
Object.loadjscssfile("file:///android_asset/static/js/app.js","js")